/// <reference types="react-reconciler" />
import * as THREE from 'three';
import * as React from 'react';
import { UseStore } from 'zustand';
import { StoreProps, context, RootState, Size } from '../core/store';
import { extend, Instance } from '../core/renderer';
import { addEffect, addAfterEffect, addTail } from '../core/loop';
import { createDOMEvents as events } from './events';
import { Canvas } from './Canvas';
import { EventManager } from '../core/events';
export declare type RenderProps<TCanvas extends Element> = Omit<StoreProps, 'gl' | 'events' | 'size'> & {
    gl?: THREE.WebGLRenderer | THREE.WebGLRendererParameters;
    events?: (store: UseStore<RootState>) => EventManager<TCanvas>;
    size?: Size;
    mode?: 'legacy' | 'blocking' | 'concurrent';
    onCreated?: (state: RootState) => void;
};
declare const invalidate: (state?: RootState | undefined) => void, advance: (timestamp: number, runGlobalEffects?: boolean, state?: RootState | undefined) => void;
declare const reconciler: import("react-reconciler").Reconciler<unknown, unknown, unknown, unknown, unknown>, applyProps: (instance: Instance, newProps: import("../core/renderer").InstanceProps, oldProps?: import("../core/renderer").InstanceProps, accumulative?: boolean) => void;
declare function render<TCanvas extends Element>(element: React.ReactNode, canvas: TCanvas, { gl, size, mode, events, onCreated, ...props }?: RenderProps<TCanvas>): UseStore<RootState>;
declare function unmountComponentAtNode<TElement extends Element>(canvas: TElement, callback?: (canvas: TElement) => void): void;
declare const act: (callback: () => import("react-reconciler").Thenable<unknown>) => import("react-reconciler").Thenable<void>;
declare function createPortal(children: React.ReactNode, container: any, impl?: any, key?: any): React.ReactNode;
export * from '../core/hooks';
export { context, render, unmountComponentAtNode, createPortal, events, reconciler, applyProps, invalidate, advance, extend, addEffect, addAfterEffect, addTail, Canvas, act, };
